<View::Base::SourceRecord
  @path={{@path}}
  @model={{@model}}
  @value={{@value}}
  @isEditor={{@isEditor}}
  @onLoad={{this.setup}}
  data-preferred-model="page"
  class="view-fragment use-highlights"
  as | page |
>
  <Layout
    @page={{page}}
    @model={{@model}}
    @size={{@deviceSize}}
    @path={{@value.modelKey}}
    as |layoutCol|
  >
    <View::Selector
      @cols={{page.cols}}
      @ignoredTypes={{this.ignoredTypes}}
      @layoutCol={{layoutCol}}
      as |col index name|
    >
      <View::Slot
        @model={{@model}}
        @deviceSize={{@deviceSize}}
        @space={{@space}}
        @value={{col}}
        @isEditor={{@isEditor}}
        @state={{@state}}
        @path={{concat @value.modelKey ".cols." index}}
        @onChangeState={{@onChangeState}}
        {{did-insert (fn this.ensureColExists name page)}}
      />
    </View::Selector>
  </Layout>
</View::Base::SourceRecord>